// limiter.cc

#include "limiter.h"

// #define DEBUG

#ifdef DEBUG
#include <stdio.h>
#endif


void SPKitLimiter::scaleBuffer()
{
    SPKitSample scale;
    SPKitSample scale1;
    SPKitSample scale2;
    SPKitSample scaleIncrement;
    int i = writeIndex;
    
#ifdef DEBUG
    printf("absMax1 = %lg, absMax2 = %lg\n", absMax1, absMax2);
#endif

    if (absMax1 <= threshold && absMax2 <= threshold)
	return;
	
    if (absMax1 > threshold)
	scale1 = threshold / absMax1;
    else
	scale1 = 1.0;
    if (absMax2 > threshold)
	scale2 = threshold / absMax2;
    else
	scale2 = 1.0;

#ifdef DEBUG
    printf("scale1 = %lg, scale2 = %lg\n", scale1, scale2);
#endif

    scaleIncrement = (scale2 - scale1) / (inputBufSize
		    / inputChannelCount);
    
    scale = scale1;
    while (i != processIndex) {
	sampleBuffer[i] *= scale;
	i++;
	i %= bufSize;
	if (i % inputChannelCount == 0)
	    scale += scaleIncrement;
    }
}
